

Z056 = {};

function Z056.prerequisitesPresent(specializations)
    Vehicle.registerJointType("cutter");
    Vehicle.registerJointType("trailerCombine");
    return SpecializationUtil.hasSpecialization(Motorized, specializations);
end;

function Z056:load(xmlFile)
			  
	local klapalewa = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.klapalewa#index"));
	if klapalewa ~= nil then
		self.klapalewa = klapalewa;
	end;
		local klapaprawa = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.klapaprawa#index"));
	if klapaprawa ~= nil then
		self.klapaprawa = klapaprawa;
	end;
local klapag = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.klapag#index"));
	if klapag ~= nil then
		self.klapag = klapag;
	end;
	local siecz = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.siecz#index"));
	if siecz ~= nil then
		self.siecz = siecz;
	end;
	local drzwi = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.drzwi#index"));
	if drzwi ~= nil then
		self.drzwi = drzwi;
	end;
		local klapach = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.klapach#index"));
	if klapach ~= nil then
		self.klapach = klapach;
	end;
		local klapak = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.klapak#index"));
	if klapak ~= nil then
		self.klapak = klapak;
	end;
		local klapas = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.klapas#index"));
	if klapas ~= nil then
		self.klapas = klapas;
	end;
		local gardziel = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.gardziel#index"));
	if gardziel ~= nil then
		self.gardziel = gardziel;
	end;

	self.thresherParticleSystems = {};
	local psName = "vehicle.thresherParticleSystem";
	Utils.loadParticleSystem(xmlFile, self.thresherParticleSystems, psName, self.components, false, nil, self.baseDirectory)

	self.CombineisFillingParticleSystems = {};
	local psName = "vehicle.CombineisFillingParticleSystem";
	Utils.loadParticleSystem(xmlFile, self.CombineisFillingParticleSystems, psName, self.components, false, nil, self.baseDirectory)

	self.acmilan99 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.acmilan99#index"));
	self.acmilan99Active = true;

	self.acmilanr = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.acmilanr#index"));
	self.acmilanrActive = true;

	self.acmilano = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.acmilano#index"));
	self.acmilanoActive = true;

	self.acmilano2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.acmilano2#index"));
	self.acmilano2Active = true;

	self.setMode = 0;
	self.grainTankUnloadingCapacity = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.grainTankUnloadingCapacity"), 10);
	self.grainTankCapacity = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.grainTankCapacity"), 200);
	
	self.grainTankCapacity2 = self.grainTankCapacity - 150;
	self.grainTankCapacity3 = self.grainTankCapacity - 151;
	self.koniec = true;
	self.dzialasypanie2 = false;
	self.speedbujanie = 3.79;
	self.kogutnew = false;

	bieg1SoundFile = Utils.getFilename("dzwiek/threshing_start2.wav", self.baseDirectory);
    	self.bieg1SoundId = createSample("LizardHor12nSound");
    	loadSample(self.bieg1SoundId, bieg1SoundFile, false);
    	self.bieg1Playing = false;

	local aiThreshingz058Sound = getXMLString(xmlFile, "vehicle.aiThreshingz058Sound#file");
		if aiThreshingz058Sound ~= nil and aiThreshingz058Sound ~= "" then
		aiThreshingz058Sound = Utils.getFilename(aiThreshingz058Sound, self.baseDirectory);
		self.aiThreshingz058SoundPitchOffset = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.aiThreshingz058Sound#pitchOffset"), 0);
		self.aiThreshingz058SoundRadius = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.aiThreshingz058Sound#radius"), 50);
		self.aiThreshingz058SoundInnerRadius = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.aiThreshingz058Sound#innerRadius"), 10);
		self.aiThreshingz058SoundVolume = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.aiThreshingz058Sound#volume"), 1);
		self.aiThreshingz058Sound = createAudioSource("aiThreshingz058Sound", aiThreshingz058Sound, self.aiThreshingz058SoundRadius, self.aiThreshingz058SoundInnerRadius, self.aiThreshingz058SoundVolume, 0);
		link(self.components[1].node, self.aiThreshingz058Sound);
		setVisibility(self.aiThreshingz058Sound, false);
	end;

		local aiCutterSound = getXMLString(xmlFile, "vehicle.aiCutterSound#file");
		if aiCutterSound ~= nil and aiCutterSound ~= "" then
		aiCutterSound = Utils.getFilename(aiCutterSound, self.baseDirectory);
		self.aiCutterSoundPitchOffset = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.aiCutterSound#pitchOffset"), 0);
		self.aiCutterSoundRadius = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.aiCutterSound#radius"), 50);
		self.aiCutterSoundInnerRadius = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.aiCutterSound#innerRadius"), 10);
		self.aiCutterSoundVolume = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.aiCutterSound#volume"), 1);
		self.aiCutterSound = createAudioSource("aiCutterSound", aiCutterSound, self.aiCutterSoundRadius, self.aiCutterSoundInnerRadius, self.aiCutterSoundVolume, 0);
		link(self.components[1].node, self.aiCutterSound);
		setVisibility(self.aiCutterSound, false);
	end;

		local aiThreshingmucarniaSound = getXMLString(xmlFile, "vehicle.aiThreshingmucarniaSound#file");
		if aiThreshingmucarniaSound ~= nil and aiThreshingmucarniaSound ~= "" then
		aiThreshingmucarniaSound = Utils.getFilename(aiThreshingmucarniaSound, self.baseDirectory);
		self.aiThreshingmucarniaSoundPitchOffset = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.aiThreshingmucarniaSound#pitchOffset"), 0);
		self.aiThreshingmucarniaSoundRadius = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.aiThreshingmucarniaSound#radius"), 50);
		self.aiThreshingmucarniaSoundInnerRadius = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.aiThreshingmucarniaSound#innerRadius"), 10);
		self.aiThreshingmucarniaSoundVolume = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.aiThreshingmucarniaSound#volume"), 1);
		self.aiThreshingmucarniaSound = createAudioSource("aiThreshingmucarniaSound", aiThreshingmucarniaSound, self.aiThreshingmucarniaSoundRadius, self.aiThreshingmucarniaSoundInnerRadius, self.aiThreshingmucarniaSoundVolume, 0);
		link(self.components[1].node, self.aiThreshingmucarniaSound);
		setVisibility(self.aiThreshingmucarniaSound, false);
	end;

	self.setVehicleRpmUp = SpecializationUtil.callSpecializationsFunction("setVehicleRpmUp");

self.animacjapasy = {};
       	     local i = 0;
       		while true do
            	local key = string.format("vehicle.animacjapasy.animacjapasow(%d)", i);

          if not hasXMLProperty(xmlFile, key) then
               break;
           end;

         	local node = Utils.indexToObject(self.components, getXMLString(xmlFile, key.."#index"));
            	local speed = Utils.getVectorNFromString(getXMLString(xmlFile, key.."#speed"), 2);
          	if node ~= nil and speed then
                table.insert(self.animacjapasy, {node=node, speed=speed});
           end;
	i = i +1;
      end;


         self.kontrolka1 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.kontrolki#olej"));
         self.kontrolka2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.kontrolki#kogut"));
         self.kontrolka3 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.kontrolki#zapychanie"));
         self.kontrolka4 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.kontrolki#zyd"));
         self.kontrolka5 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.kontrolki#f"));
         self.kontrolka6 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.kontrolki#g"));


-------------------------------------||--wajchy--||----------------------------------
         local rotationPartNodewajcha = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.wajcha#index"));
    if rotationPartNodewajcha ~= nil then
        self.rotationPartwajcha = {};
        self.rotationPartwajcha.node = rotationPartNodewajcha;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartwajcha#minRot"));
        self.rotationPartwajcha.minRot = {};
        self.rotationPartwajcha.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartwajcha.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartwajcha.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.wajcha#maxRot"));
        self.rotationPartwajcha.maxRot = {};
        self.rotationPartwajcha.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartwajcha.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartwajcha.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartwajcha.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.wajcha#rotTime"), 2)*1000;
        self.rotationPartwajcha.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.wajcha#touchRotLimit"), 10));
    end;
         local rotationPartNodewajcha2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.wajcha2#index"));
    if rotationPartNodewajcha2 ~= nil then
        self.rotationPartwajcha2 = {};
        self.rotationPartwajcha2.node = rotationPartNodewajcha2;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartwajcha2#minRot"));
        self.rotationPartwajcha2.minRot = {};
        self.rotationPartwajcha2.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartwajcha2.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartwajcha2.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.wajcha2#maxRot"));
        self.rotationPartwajcha2.maxRot = {};
        self.rotationPartwajcha2.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartwajcha2.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartwajcha2.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartwajcha2.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.wajcha2#rotTime"), 2)*1000;
        self.rotationPartwajcha2.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.wajcha2#touchRotLimit"), 10));
    end;
         local rotationPartNodewajcha3 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.wajcha3#index"));
    if rotationPartNodewajcha3 ~= nil then
        self.rotationPartwajcha3 = {};
        self.rotationPartwajcha3.node = rotationPartNodewajcha3;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartwajcha3#minRot"));
        self.rotationPartwajcha3.minRot = {};
        self.rotationPartwajcha3.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartwajcha3.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartwajcha3.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.wajcha3#maxRot"));
        self.rotationPartwajcha3.maxRot = {};
        self.rotationPartwajcha3.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartwajcha3.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartwajcha3.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartwajcha3.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.wajcha3#rotTime"), 2)*1000;
        self.rotationPartwajcha3.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.wajcha3#touchRotLimit"), 10));
    end;
         local rotationPartNodewajcha4 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.wajcha4#index"));
    if rotationPartNodewajcha4 ~= nil then
        self.rotationPartwajcha4 = {};
        self.rotationPartwajcha4.node = rotationPartNodewajcha4;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartwajcha4#minRot"));
        self.rotationPartwajcha4.minRot = {};
        self.rotationPartwajcha4.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartwajcha4.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartwajcha4.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.wajcha4#maxRot"));
        self.rotationPartwajcha4.maxRot = {};
        self.rotationPartwajcha4.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartwajcha4.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartwajcha4.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartwajcha4.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.wajcha4#rotTime"), 2)*1000;
        self.rotationPartwajcha4.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.wajcha4#touchRotLimit"), 10));
    end;
      local rotationPartNodewajcha5 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.wajcha5#index"));
    if rotationPartNodewajcha5 ~= nil then
        self.rotationPartwajcha5 = {};
        self.rotationPartwajcha5.node = rotationPartNodewajcha5;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartwajcha5#minRot"));
        self.rotationPartwajcha5.minRot = {};
        self.rotationPartwajcha5.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartwajcha5.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartwajcha5.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.wajcha5#maxRot"));
        self.rotationPartwajcha5.maxRot = {};
        self.rotationPartwajcha5.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartwajcha5.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartwajcha5.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartwajcha5.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.wajcha5#rotTime"), 2)*1000;
        self.rotationPartwajcha5.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.wajcha5#touchRotLimit"), 10));
    end;
      local rotationPartNodewajcha6 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.wajcha6#index"));
    if rotationPartNodewajcha6 ~= nil then
        self.rotationPartwajcha6 = {};
        self.rotationPartwajcha6.node = rotationPartNodewajcha6;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartwajcha6#minRot"));
        self.rotationPartwajcha6.minRot = {};
        self.rotationPartwajcha6.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartwajcha6.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartwajcha6.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.wajcha6#maxRot"));
        self.rotationPartwajcha6.maxRot = {};
        self.rotationPartwajcha6.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartwajcha6.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartwajcha6.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartwajcha6.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.wajcha6#rotTime"), 2)*1000;
        self.rotationPartwajcha6.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.wajcha6#touchRotLimit"), 10));
    end;
      local rotationPartNodewajcha7 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.wajcha7#index"));
    if rotationPartNodewajcha7 ~= nil then
        self.rotationPartwajcha7 = {};
        self.rotationPartwajcha7.node = rotationPartNodewajcha7;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartwajcha7#minRot"));
        self.rotationPartwajcha7.minRot = {};
        self.rotationPartwajcha7.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartwajcha7.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartwajcha7.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.wajcha7#maxRot"));
        self.rotationPartwajcha7.maxRot = {};
        self.rotationPartwajcha7.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartwajcha7.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartwajcha7.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartwajcha7.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.wajcha7#rotTime"), 2)*1000;
        self.rotationPartwajcha7.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.wajcha7#touchRotLimit"), 10));
    end;
      local rotationPartNodewajcha8 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.wajcha8#index"));
    if rotationPartNodewajcha8 ~= nil then
        self.rotationPartwajcha8 = {};
        self.rotationPartwajcha8.node = rotationPartNodewajcha8;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartwajcha8#minRot"));
        self.rotationPartwajcha8.minRot = {};
        self.rotationPartwajcha8.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartwajcha8.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartwajcha8.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.wajcha8#maxRot"));
        self.rotationPartwajcha8.maxRot = {};
        self.rotationPartwajcha8.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartwajcha8.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartwajcha8.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartwajcha8.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.wajcha8#rotTime"), 2)*1000;
        self.rotationPartwajcha8.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.wajcha8#touchRotLimit"), 10));
    end;
      local rotationPartNodewajcha9 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.wajcha9#index"));
    if rotationPartNodewajcha9 ~= nil then
        self.rotationPartwajcha9 = {};
        self.rotationPartwajcha9.node = rotationPartNodewajcha9;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartwajcha9#minRot"));
        self.rotationPartwajcha9.minRot = {};
        self.rotationPartwajcha9.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartwajcha9.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartwajcha9.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.wajcha9#maxRot"));
        self.rotationPartwajcha9.maxRot = {};
        self.rotationPartwajcha9.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartwajcha9.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartwajcha9.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartwajcha9.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.wajcha9#rotTime"), 2)*1000;
        self.rotationPartwajcha9.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.wajcha9#touchRotLimit"), 10));
    end;
      local rotationPartNodewajcha10 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.wajcha10#index"));
    if rotationPartNodewajcha10 ~= nil then
        self.rotationPartwajcha10 = {};
        self.rotationPartwajcha10.node = rotationPartNodewajcha10;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartwajcha10#minRot"));
        self.rotationPartwajcha10.minRot = {};
        self.rotationPartwajcha10.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartwajcha10.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartwajcha10.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.wajcha10#maxRot"));
        self.rotationPartwajcha10.maxRot = {};
        self.rotationPartwajcha10.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartwajcha10.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartwajcha10.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartwajcha10.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.wajcha10#rotTime"), 2)*1000;
        self.rotationPartwajcha10.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.wajcha10#touchRotLimit"), 10));
    end;


-------------||--wajcha biegi--||------------------
        local rotationPartNodetet1 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.tet1#index"));
    if rotationPartNodetet1 ~= nil then
        self.rotationParttet1 = {};
        self.rotationParttet1.node = rotationPartNodetet1;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationParttet1#minRot"));
        self.rotationParttet1.minRot = {};
        self.rotationParttet1.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationParttet1.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationParttet1.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.tet1#maxRot"));
        self.rotationParttet1.maxRot = {};
        self.rotationParttet1.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationParttet1.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationParttet1.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationParttet1.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.tet1#rotTime"), 2)*1000;
        self.rotationParttet1.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.tet1#touchRotLimit"), 10));
    end;
        local rotationPartNodetet2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.tet2#index"));
    if rotationPartNodetet2 ~= nil then
        self.rotationParttet2 = {};
        self.rotationParttet2.node = rotationPartNodetet2;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationParttet2#minRot"));
        self.rotationParttet2.minRot = {};
        self.rotationParttet2.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationParttet2.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationParttet2.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.tet2#maxRot"));
        self.rotationParttet2.maxRot = {};
        self.rotationParttet2.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationParttet2.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationParttet2.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationParttet2.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.tet2#rotTime"), 2)*1000;
        self.rotationParttet2.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.tet2#touchRotLimit"), 10));
    end;
        local rotationPartNodetet3 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.tet3#index"));
    if rotationPartNodetet3 ~= nil then
        self.rotationParttet3 = {};
        self.rotationParttet3.node = rotationPartNodetet3;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationParttet3#minRot"));
        self.rotationParttet3.minRot = {};
        self.rotationParttet3.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationParttet3.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationParttet3.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.tet3#maxRot"));
        self.rotationParttet3.maxRot = {};
        self.rotationParttet3.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationParttet3.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationParttet3.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationParttet3.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.tet3#rotTime"), 2)*1000;
        self.rotationParttet3.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.tet3#touchRotLimit"), 10));
    end;
        local rotationPartNodetetr = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.tetr#index"));
    if rotationPartNodetetr ~= nil then
        self.rotationParttetr = {};
        self.rotationParttetr.node = rotationPartNodetetr;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationParttetr#minRot"));
        self.rotationParttetr.minRot = {};
        self.rotationParttetr.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationParttetr.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationParttetr.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.tetr#maxRot"));
        self.rotationParttetr.maxRot = {};
        self.rotationParttetr.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationParttetr.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationParttetr.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationParttetr.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.tetr#rotTime"), 2)*1000;
        self.rotationParttetr.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.tetr#touchRotLimit"), 10));
    end;
----------------------------------
 	local rotationPartNodeabl1 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.abl1#index"));
    if rotationPartNodeabl1 ~= nil then
        self.rotationPartabl1 = {};
        self.rotationPartabl1.node = rotationPartNodeabl1;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartabl1#minRot"));
        self.rotationPartabl1.minRot = {};
        self.rotationPartabl1.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartabl1.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartabl1.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.abl1#maxRot"));
        self.rotationPartabl1.maxRot = {};
        self.rotationPartabl1.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartabl1.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartabl1.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartabl1.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.abl1#rotTime"), 2)*1000;
        self.rotationPartabl1.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.abl1#touchRotLimit"), 10));
    end;
    local rotationPartNodeabl2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.abl2#index"));
    if rotationPartNodeabl2 ~= nil then
        self.rotationPartabl2 = {};
        self.rotationPartabl2.node = rotationPartNodeabl2;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartabl2#minRot"));
        self.rotationPartabl2.minRot = {};
        self.rotationPartabl2.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartabl2.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartabl2.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.abl2#maxRot"));
        self.rotationPartabl2.maxRot = {};
        self.rotationPartabl2.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartabl2.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartabl2.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartabl2.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.abl2#rotTime"), 2)*1000;
        self.rotationPartabl2.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.abl2#touchRotLimit"), 10));
    end;
    local rotationPartNodehidra1 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.hidra1#index"));
    if rotationPartNodehidra1 ~= nil then
        self.rotationParthidra1 = {};
        self.rotationParthidra1.node = rotationPartNodehidra1;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationParthidra1#minRot"));
        self.rotationParthidra1.minRot = {};
        self.rotationParthidra1.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationParthidra1.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationParthidra1.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.hidra1#maxRot"));
        self.rotationParthidra1.maxRot = {};
        self.rotationParthidra1.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationParthidra1.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationParthidra1.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationParthidra1.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.hidra1#rotTime"), 2)*1000;
        self.rotationParthidra1.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.hidra1#touchRotLimit"), 10));
    end;
        local rotationPartNodehidra2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.hidra2#index"));
    if rotationPartNodehidra2 ~= nil then
        self.rotationParthidra2 = {};
        self.rotationParthidra2.node = rotationPartNodehidra2;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationParthidra2#minRot"));
        self.rotationParthidra2.minRot = {};
        self.rotationParthidra2.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationParthidra2.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationParthidra2.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.hidra2#maxRot"));
        self.rotationParthidra2.maxRot = {};
        self.rotationParthidra2.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationParthidra2.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationParthidra2.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationParthidra2.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.hidra2#rotTime"), 2)*1000;
        self.rotationParthidra2.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.hidra2#touchRotLimit"), 10));
    end;
       local rotationPartNodehidra3 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.hidra3#index"));
    if rotationPartNodehidra3 ~= nil then
        self.rotationParthidra3 = {};
        self.rotationParthidra3.node = rotationPartNodehidra3;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationParthidra3#minRot"));
        self.rotationParthidra3.minRot = {};
        self.rotationParthidra3.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationParthidra3.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationParthidra3.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.hidra3#maxRot"));
        self.rotationParthidra3.maxRot = {};
        self.rotationParthidra3.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationParthidra3.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationParthidra3.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationParthidra3.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.hidra3#rotTime"), 2)*1000;
        self.rotationParthidra3.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.hidra3#touchRotLimit"), 10));
        
    end;
      local rotationPartNodehidra31 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.hidra31#index"));
    if rotationPartNodehidra31 ~= nil then
        self.rotationParthidra31 = {};
        self.rotationParthidra31.node = rotationPartNodehidra31;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationParthidra31#minRot"));
        self.rotationParthidra31.minRot = {};
        self.rotationParthidra31.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationParthidra31.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationParthidra31.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.hidra31#maxRot"));
        self.rotationParthidra31.maxRot = {};
        self.rotationParthidra31.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationParthidra31.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationParthidra31.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationParthidra31.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.hidra31#rotTime"), 2)*1000;
        self.rotationParthidra31.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.hidra31#touchRotLimit"), 10));
        
    end;
    	local rotationPartNodesprzeglo5 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.waj_podn#index"));
   	 if rotationPartNodesprzeglo5 ~= nil then
        self.rotationPartsprzeglo5 = {};
        self.rotationPartsprzeglo5.node = rotationPartNodesprzeglo5;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.waj_podn#minRot"));
        self.rotationPartsprzeglo5.minRot = {};
        self.rotationPartsprzeglo5.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartsprzeglo5.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartsprzeglo5.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.waj_podn#maxRot"));
        self.rotationPartsprzeglo5.maxRot = {};
        self.rotationPartsprzeglo5.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartsprzeglo5.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartsprzeglo5.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartsprzeglo5.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.waj_podn#rotTime"), 2)*1000;
        self.rotationPartsprzeglo5.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.waj_podn#touchRotLimit"), 10));
    end;
	local rotationPartNodesprzeglo6 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.waj_podn2#index"));
   	 if rotationPartNodesprzeglo6 ~= nil then
        self.rotationPartsprzeglo6 = {};
        self.rotationPartsprzeglo6.node = rotationPartNodesprzeglo6;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.waj_podn2#minRot"));
        self.rotationPartsprzeglo6.minRot = {};
        self.rotationPartsprzeglo6.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartsprzeglo6.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartsprzeglo6.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.waj_podn2#maxRot"));
        self.rotationPartsprzeglo6.maxRot = {};
        self.rotationPartsprzeglo6.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartsprzeglo6.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartsprzeglo6.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartsprzeglo6.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.waj_podn2#rotTime"), 2)*1000;
        self.rotationPartsprzeglo6.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.waj_podn2#touchRotLimit"), 10));
    end;
 -----------   

 self.kogutAnz = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.kogut#count"),0);
    self.kogutKey = getXMLString(xmlFile, "vehicle.kogut#key");
    self.kogutAn = false;
    self.kogut = {};
    for i=1, self.kogutAnz do
        local objname = string.format("vehicle.kogut.light" .. "%d",i);
        self.kogut[i] = {};
        self.kogut[i].rotNode = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, objname .. "#rotNode"));
        self.kogut[i].light = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, objname .. "#light"));
        self.kogut[i].source = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, objname .. "#lightsource"));
        self.kogut[i].speed = Utils.getNoNil(getXMLInt(xmlFile,  objname .. "#rotSpeed"), 1)/1000;
        self.kogut[i].emit = Utils.getNoNil(getXMLBool(xmlFile, objname .. "#emitLight"), true);
        if not self.kogut[i].emit and self.kogut[i].source ~= nil then
           setVisibility(self.kogut[i].source, false);
        end;
    end;

   	local hydraulicsCount = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.hydraulics#count"), 0);	
	self.hydraulics = {};	
	for i=1, hydraulicsCount do
		local hydraulicName = string.format("vehicle.hydraulics.hydraulic%d", i);		
		self.hydraulics[i] = {};		
		self.hydraulics[i].node = Utils.indexToObject(self.components, getXMLString(xmlFile, hydraulicName .. "#index"));
		self.hydraulics[i].punch = Utils.indexToObject(self.components, getXMLString(xmlFile, hydraulicName .. "#punch"));
		self.hydraulics[i].translationPunch = Utils.indexToObject(self.components, getXMLString(xmlFile, hydraulicName .. "#punchFixpoint"));
		self.hydraulics[i].fixPoint = Utils.indexToObject(self.components, getXMLString(xmlFile, hydraulicName .. "#fixpoint"));	
		local xUp, yUp, zUp = Utils.getVectorFromString(Utils.getNoNil(getXMLString(xmlFile, hydraulicName .. "#upVectors"),"0 1 0"));
		self.hydraulics[i].upVectors = {xUp, yUp, zUp};
		
		local ax, ay, az;		
		if self.hydraulics[i].punch ~= nil then
			ax, ay, az = getWorldTranslation(self.hydraulics[i].punch);
		else
			ax, ay, az = getWorldTranslation(self.hydraulics[i].node);
		end;
		if self.hydraulics[i].translationPunch ~= nil then
			local bx, by, bz = getWorldTranslation(self.hydraulics[i].translationPunch);		
			self.hydraulics[i].punchDistance = Utils.vector3Length(ax-bx, ay-by, az-bz);
		end;
	end;
	self.setHydraulicTime = 30;	




    	skretSoundFile = Utils.getFilename("dzwiek/skret.wav", self.baseDirectory);
    	self.skretSoundId = createSample("dzwiek_hydro");
    	loadSample(self.skretSoundId, skretSoundFile, false);
    

		
		
		

    local motorMaxRpmStr = getXMLString(xmlFile, "vehicle.motor#maxRpm");
    local motorMaxRpm1, motorMaxRpm2, motorMaxRpm3 = Utils.getVectorFromString(motorMaxRpmStr);
    motorMaxRpm1 = Utils.getNoNil(motorMaxRpm1, 650);
    motorMaxRpm2 = Utils.getNoNil(motorMaxRpm2, 1000);
    motorMaxRpm3 = Utils.getNoNil(motorMaxRpm3, 1800);
    local motorMaxRpm = {motorMaxRpm1, motorMaxRpm2, motorMaxRpm3};
    self.motorMaxRpmLimit = motorMaxRpm;
	
		local rotationPartNodepedalhamulca = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.pedal_hamulca#index"));
    if rotationPartNodepedalhamulca ~= nil then
        self.rotationPartpedalhamulca = {};
        self.rotationPartpedalhamulca.node = rotationPartNodepedalhamulca;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.pedal_hamulca#minRot"));
        self.rotationPartpedalhamulca.minRot = {};
        self.rotationPartpedalhamulca.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartpedalhamulca.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartpedalhamulca.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.pedal_hamulca#maxRot"));
        self.rotationPartpedalhamulca.maxRot = {};
        self.rotationPartpedalhamulca.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartpedalhamulca.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartpedalhamulca.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartpedalhamulca.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.pedal_hamulca#rotTime"), 2)*1000;
        self.rotationPartpedalhamulca.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.pedal_hamulca#touchRotLimit"), 10));
    end;

	
self.halogenyActive = false
self.halogen2Active = false


self.startThreshingExhaustParticleSystems = {};
	local exhaustParticleSystemCount = Utils.getNoNil(getXMLInt(xmlFile, "vehicle.startThreshingExhaustParticleSystems#count"), 0);
	for i=1, exhaustParticleSystemCount do
		local namei = string.format("vehicle.startThreshingExhaustParticleSystems.startThreshingExhaustParticleSystem%d", i);
		Utils.loadParticleSystem(xmlFile, self.startThreshingExhaustParticleSystems, namei, self.components, false, nil, self.baseDirectory)
	end;
	
	self.threshingEnableTime = nil;





    	local rotationPartNodepret = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.pret#index"));
    if rotationPartNodepret ~= nil then
        self.rotationPartpret = {};
        self.rotationPartpret.node = rotationPartNodepret;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.rotationPartpret#minRot"));
        self.rotationPartpret.minRot = {};
        self.rotationPartpret.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartpret.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartpret.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.pret#maxRot"));
        self.rotationPartpret.maxRot = {};
        self.rotationPartpret.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.rotationPartpret.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.rotationPartpret.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.rotationPartpret.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.pret#rotTime"), 2)*1000;
        self.rotationPartpret.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.pret#touchRotLimit"), 10));
    end;

      hor1nSoundFile = Utils.getFilename("dzwiek/superHor1n.wav", self.baseDirectory);
    self.hor1nSoundId = createSample("LizardHor1nSound");
    loadSample(self.hor1nSoundId, hor1nSoundFile, false);
    self.hor1nPlaying = false;
        self.gazPlaying = false;
            self.gaz2Playing = false;

 startsypanieSoundFile = Utils.getFilename("dzwiekisypanie/sypanie_start.wav", self.baseDirectory);
    self.startsypanieSoundId = createSample("LizardstartsypanieSound");
    loadSample(self.startsypanieSoundId, startsypanieSoundFile, false);
    self.startsypaniePlaying = false;


      hor12nSoundFile = Utils.getFilename("dzwiek/superHor12n.wav", self.baseDirectory);
    self.hor12nSoundId = createSample("LizardHor12nSound");
    loadSample(self.hor12nSoundId, hor12nSoundFile, false);
    self.hor12nPlaying = false;

 koniecsypanieSoundFile = Utils.getFilename("dzwiekisypanie/koniec_sypania.wav", self.baseDirectory);
    self.koniecsypanieSoundId = createSample("LizardkoniecsypanieSound");
    loadSample(self.koniecsypanieSoundId, koniecsypanieSoundFile, false);
    self.koniecsypaniePlaying = false;

      local mowe2r25Sound = getXMLString(xmlFile, "vehicle.mowe2r25Sound#file");
    if mowe2r25Sound ~= nil and mowe2r25Sound ~= "" then
        mowe2r25Sound = Utils.getFilename(mowe2r25Sound, self.baseDirectory);
        self.mowe2r25Sound = createSample("mowe2r25Sound");
        self.mowe2r25SoundEnabled = false;
        loadSample(self.mowe2r25Sound, mowe2r25Sound, false);
        self.mowe2r25SoundPitchOffset = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.mowe2r25Sound#pitchOffset"), 1);
        self.mowe2r25SoundVolume = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.mowe2r25Sound#volume"), 1);
    end;
    
     local cutterSound = getXMLString(xmlFile, "vehicle.cutterSound#file");
    if cutterSound ~= nil and cutterSound ~= "" then
        cutterSound = Utils.getFilename(cutterSound, self.baseDirectory);
        self.cutterSound = createSample("cutterSound");
        loadSample(self.cutterSound, cutterSound, false);
    end;
    
     local cutter2Sound = getXMLString(xmlFile, "vehicle.wysyp#file");
    if cutter2Sound ~= nil and cutter2Sound ~= "" then
        cutter2Sound = Utils.getFilename(cutter2Sound, self.baseDirectory);
        self.cutter2Sound = createSample("cutter2Sound");
        loadSample(self.cutter2Sound, cutter2Sound, false);
    end;

	local cutter3Sound = getXMLString(xmlFile, "vehicle.wysyp2#file");
    	if cutter3Sound ~= nil and cutter3Sound ~= "" then
        cutter3Sound = Utils.getFilename(cutter3Sound, self.baseDirectory);
        self.cutter3Sound = createSample("cutter3Sound");
        loadSample(self.cutter3Sound, cutter3Sound, false);
    end;
self.cutter3SoundPlaying = false;
    
        hor21nSoundFile = Utils.getFilename("dzwiek/superHor21n.wav", self.baseDirectory);
    self.hor21nSoundId = createSample("LizardHor21nSound");
    loadSample(self.hor21nSoundId, hor21nSoundFile, false);
    self.hor21nPlaying = false;
        self.gazPlaying = false;
            self.gaz2Playing = false;


         local mower25Sound = getXMLString(xmlFile, "vehicle.mower25Sound#file");
    if mower25Sound ~= nil and mower25Sound ~= "" then
        mower25Sound = Utils.getFilename(mower25Sound, self.baseDirectory);
        self.mower25Sound = createSample("mower25Sound");
        self.mower25SoundEnabled = false;
        loadSample(self.mower25Sound, mower25Sound, false);
        self.mower25SoundPitchOffset = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.mower25Sound#pitchOffset"), 1);
        self.mower25SoundVolume = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.mower25Sound#volume"), 1);
    end;

 local sypaniedzialaSound = getXMLString(xmlFile, "vehicle.sypaniedziala#file");
    if sypaniedzialaSound ~= nil and sypaniedzialaSound ~= "" then
        sypaniedzialaSound = Utils.getFilename(sypaniedzialaSound, self.baseDirectory);
        self.sypaniedzialaSound = createSample("sypaniedzialaSound");
        self.sypaniedzialaSoundEnabled = false;
        loadSample(self.sypaniedzialaSound, sypaniedzialaSound, false);
        self.sypaniedzialaSoundPitchOffset = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.sypaniedziala#pitchOffset"), 1);
        self.sypaniedzialaSoundVolume = Utils.getNoNil(getXMLFloat(xmlFile, "vehicle.sypaniedziala#volume"), 1);
    end;

  	self.czas4 = 0;
	self.czas2 = 0;
    self.dodaniegazu = false;
    self.gaz = false;
    self.odjeciegazu = false;
    self.setHydraulicDirection = SpecializationUtil.callSpecializationsFunction("setHydraulicDirection");
    self.zapalony = 0;
    self.zapychanie = 0;
    
      self.hudInfoBasePosX = 0.52;
    self.hudInfoBaseWidth = 0.50;
    self.hudInfoBasePosY = 0.445;
    self.hudInfoBaseHeight = 0.50;
    self.infoPanelPath = Utils.getFilename("Bizon.png", self.baseDirectory);
	  self.hudInfoBaseOverlay = Overlay:new("hudInfoBaseOverlay", self.infoPanelPath, self.hudInfoBasePosX, self.hudInfoBasePosY, self.hudInfoBaseWidth, self.hudInfoBaseHeight);
    self.showHudInfoBase = false;

    self.down = false;
    self.down2 = false;
    
end;

function Z056:delete()
 if self.mower25Sound ~= nil then
        delete(self.mower25Sound);
    end;
if self.sypaniedzialaSound ~= nil then
        delete(self.sypaniedzialaSound);
    end;
     if self.mowe2r25Sound ~= nil then
        delete(self.mowe2r25Sound);
    end;
      if self.cutterSound ~= nil then
        delete(self.cutterSound);
    end;
     if self.cutter2Sound ~= nil then
        delete(self.cutter2Sound);
    end;
if self.cutter3Sound ~= nil then
        delete(self.cutter3Sound);
    end;
Utils.deleteParticleSystem(self.thresherParticleSystems);
Utils.deleteParticleSystem(self.CombineisFillingParticleSystems);
Utils.deleteParticleSystem(self.startThreshingExhaustParticleSystems);
end;

function Z056:keyEvent(unicode, sym, modifier, isDown)


--------------------------------//--WAJCHY--\\--------------------
if isDown and sym == Input.KEY_k and self.isMotorStarted then
	self.zapal = not self.zapal;
    end;
if isDown and sym == Input.KEY_b and self.isMotorStarted then
	self.zapal2 = not self.zapal2;
    end;
	
	----------motowidla szybciej wolniej--------------------
	if Input.isKeyPressed(Input.KEY_KP_9) then
			self.rotationMaxwajcha3 = true;
		else
			self.rotationMaxwajcha3 = false;
	end;
	if Input.isKeyPressed(Input.KEY_KP_7) then
        	self.rotationMaxwajcha4 = true;
		else
			self.rotationMaxwajcha4 = false;
	end;
	----------------------------wariator----------------
	if Input.isKeyPressed(Input.KEY_KP_plus) then
			self.rotationMaxwajcha5 = true;
		else
			self.rotationMaxwajcha5 = false;
	end;
	if Input.isKeyPressed(Input.KEY_KP_minus) then
			self.rotationMaxwajcha6 = true;
		else
			self.rotationMaxwajcha6 = false;
	end;
	-----------------------motowidla gora dol-------------
	if Input.isKeyPressed(Input.KEY_KP_5) then
			self.rotationMaxwajcha = true;
		else
			self.rotationMaxwajcha = false;
	end;
	if Input.isKeyPressed(Input.KEY_KP_8) then
			self.rotationMaxwajcha2 = true;
		else
			self.rotationMaxwajcha2 = false;
	end;
	------------------------------motowidla przod tyl-------------------
   	if Input.isKeyPressed(Input.KEY_KP_6) then
			self.rotationMaxwajcha9 = true;
		else
			self.rotationMaxwajcha9 = false;
	end;
	if Input.isKeyPressed(Input.KEY_KP_4) then
        	self.rotationMaxwajcha10 = true;
		else
			self.rotationMaxwajcha10 = false;
	end;
-----------------//--KONIEC WAJCH--\\---------------------




    if self.isEntered then
      if self.kogutKey ~= nil then
         if isDown and sym == Input[self.kogutKey] then
           self.kogutAn = not self.kogutAn;
           for i=1, self.kogutAnz do
             setVisibility(self.kogut[i].light, self.kogutAn);
           end;
         end;
      end;
    end;

	   if isDown and sym == Input.KEY_0 then
		self.info = not self.info;
	end;

	if isDown and sym == Input.KEY_f2 or isDown and sym == Input.KEY_f3 then
		self.dym = not self.dym;
	end;

	if isDown and sym == Input.KEY_f4 then
		self.obroty = not self.obroty;
	end;
if isDown and sym == Input.KEY_home then
		self.acmilanrActive = not self.acmilanrActive;
	end;
if isDown and sym == Input.KEY_f5 then
		self.acmilanoActive = not self.acmilanoActive;
	end;
if isDown and sym == Input.KEY_f6 then
		self.acmilano2Active = not self.acmilano2Active;
	end;
		if isDown and sym == Input.KEY_7 then
		self.halogen2Active = not self.halogen2Active;
	end;

	if isDown and sym == Input.KEY_f10 then
		self.setMode = self.setMode + 1;
	end;

end;

function Z056:update(dt)

if self.isEntered then
	if Input.isKeyPressed(Input.KEY_f2) or self.setMode == 3 then
		if self.threshingEnableTime == nil then
			self.threshingEnableTime = self.time;
		end;
	else
		self.threshingEnableTime = nil;
	end;
	
	if self.isClient then
		if self.threshingEnableTime ~= nil and self.time <= (self.threshingEnableTime + 4400) then
			Utils.setEmittingState(self.startThreshingExhaustParticleSystems, true);
		else
			Utils.setEmittingState(self.startThreshingExhaustParticleSystems, false);
		end;
	end;

	if self.setMode == 2 then
		if self.increaseRpmDuringPloughing then
			self:setVehicleRpmUp(dt, true);
		end;
	elseif self.setMode == 3 then
		if self.increaseRpmDuringPloughing then
			self:setVehicleRpmUp(dt, false);
		end;
	end;
end;
	if self.gaz and not self:getIsActiveForSound() then
		if self.aiThreshingz058Sound ~= nil then
			setVisibility(self.aiThreshingz058Sound, true);
		end;
	else
		if self.aiThreshingz058Sound ~= nil then
			setVisibility(self.aiThreshingz058Sound, false);
		end;		
	end;

	if self.animationParts[11].clipEndTime and self.gaz and not self:getIsActiveForSound() then
		if self.aiCutterSound ~= nil then
			setVisibility(self.aiCutterSound, true);
		end;
	else
		if self.aiCutterSound ~= nil then
			setVisibility(self.aiCutterSound, false);
		end;		
	end;

	if self.isThreshing and not self:getIsActiveForSound() then
		if self.aiThreshingmucarniaSound ~= nil then
			setVisibility(self.aiThreshingmucarniaSound, true);
		end;
	else
		if self.aiThreshingmucarniaSound ~= nil then
			setVisibility(self.aiThreshingmucarniaSound, false);
		end;		
	end;

	if self.animationParts[13].clipEndTime and self.combineIsFilling then
		Utils.setEmittingState(self.CombineisFillingParticleSystems, true);
	else
		Utils.setEmittingState(self.CombineisFillingParticleSystems, false);
	end;
if self.isEntered then
  if self.setMode == 1 then
	self.motor.minRpm = -1000;
	self.grainTankUnloadingCapacity = 60;
	self.koniec = true;
  elseif self.setMode == 2 then
	self.motor.minRpm = -1500;
	self.grainTankUnloadingCapacity = 70;
  elseif self.setMode == 3 then
	self.motor.minRpm = -2500;
	self.grainTankUnloadingCapacity = 100;
  elseif self.setMode == 4 then
	self.motor.minRpm = 100;
	self.setMode = 0;
	self.koniec = false;
	self.grainTankUnloadingCapacity = 50;
   end;

	if self.kogutnew or self.grainTankFillLevel > self.grainTankCapacity2 then
		self:setBeaconLightsVisibility(true);
	elseif not self.kogutnew or self.grainTankFillLevel < self.grainTankCapacity3 then
		self:setBeaconLightsVisibility(false);
	end;

if self.animationParts[10].clipEndTime then
if self.sound1 then
       if not self.bieg1Playing then
            playSample(self.bieg1SoundId, 1, 3, 3);
            self.bieg1Playing = true;
        end;
       
    else
        if self.bieg1Playing then
            stopSample(self.bieg1SoundId);
            self.bieg1Playing = false;
        end;
end;
end;
end;

if InputBinding.hasEvent(InputBinding.TOGGLE_BEACON_LIGHTS) then
		self.kogutnew = not self.kogutnew;
end;


if self.isEntered then
	if InputBinding.isPressed(InputBinding.GARDZIELDOWN) then
		self.down = true;
			else
    		self.down = false;
	end;
	if InputBinding.isPressed(InputBinding.GARDZIELUP) then
		self.down2 = true;
			else
    		self.down2 = false;
	end;


	if self.down == true then
		self.rotationMaxwajcha7 = true;
	elseif self.down == false then
		self.rotationMaxwajcha7 = false;
	end; 
	if self.down2 == true then
		self.rotationMaxwajcha7 = true;
	elseif self.down2 == false then
		self.rotationMaxwajcha7 = false;
	end; 

end;

 if self.isMotorStarted then
    self.zapalony = self.zapalony +(dt/1);
  else
  	self.zapalony = 0
  end;

if self.siecz then
		if InputBinding.hasEvent(InputBinding.siecz) then
				self:setIsStrawActive(not self.isStrawActive);
				self.slomaActive = not self.slomaActive;
			if self.animationParts[17].clipEndTime then
				self:setAnimationTime(17, self.animationParts[17].offSet);
			elseif self.animationParts[17].clipStartTime then
				self:setAnimationTime(17, self.animationParts[17].animDuration);
			end;
		end;
	end;


if self.drzwi or self.isEntered then
	if InputBinding.hasEvent(InputBinding.drzwi) then
			if self.animationParts[18].clipEndTime then
				self:setAnimationTime(18, self.animationParts[18].offSet);
			elseif self.animationParts[18].clipStartTime then
				self:setAnimationTime(18, self.animationParts[18].animDuration);
			end;
		end;
end;

if self.isEntered then
---cisnienie oleju--
   if self.zapalony < 3000 then
   self.kontrolka1on = true
   else
   self.kontrolka1on = false;
   end;

--kontrolki
   ---kogut---
   if self.kogutAn then
   self.kontrolka2on = true
   else
   self.kontrolka2on = false;
   end;

   ---zyd--
   if self.fuelFillLevel < 75 then
   self.kontrolka4on = true
   else
   self.kontrolka4on = false;
   end;

if self.isEntered then
	if self.isThreshing then
		for _, part in pairs(self.animacjapasy) do
          	setShaderParameter(part.node, "uvScrollSpeed", self.animationParts[7].clipSpeed/0.99*part.speed[1], self.animationParts[7].clipSpeed/0.99*part.speed[2], 0, 0, false);
		Utils.setEmittingState(self.thresherParticleSystems, true);
      end;
	elseif not self.isThreshing then
		for _, part in pairs(self.animacjapasy) do
          	setShaderParameter(part.node, "uvScrollSpeed", 0, 0, 0, 0, false);
		Utils.setEmittingState(self.thresherParticleSystems, false);
	end;
     end;
end;
if self.slomaActive then
		self.acmilan99Active = false;
else
		self.acmilan99Active = true;
	end; 

setVisibility(self.acmilan99, self.acmilan99Active);
setVisibility(self.acmilanr, self.acmilanrActive);
setVisibility(self.acmilano, self.acmilanoActive);
setVisibility(self.acmilano2, self.acmilano2Active);

--liczniki--
  ------obr silnika
  if self.isMotorStarted then
    if self.isThreshing then
         self.rotationMaxabl1 = true; --wolne
      if self.dodaniegazu or self.gaz or self.lastSpeed*3600 > 13 then
         self.rotationMaxhidra2 = true; --full na niskich
            if self.lastArea > 0  then
                 self.rotationMaxhidra1 = false; --opadanie
                   if self.obroty then
             self.rotationMaxabl2 = true; --100 %
             else
             self.rotationMaxabl2 = false; --100 %
            end
                else
               self.rotationMaxhidra1 = true;
               end;

        elseif not self.gaz then
       self.rotationMaxhidra2 = false
       end
	 else
	 self.rotationMaxabl1 = false; --wolne
end
end;
 if self.isMotorStarted then
   self.rotationMaxhidra3 = true;
    if self.dodaniegazu or self.gaz or self.lastSpeed*3600 > 13 then
     self.rotationMaxhidra31 = true;
    elseif not self.gaz then
      self.rotationMaxhidra31 = false;
    end
     self.rotationMaxhidra3 = false;
 else
 
 end   
-------------------

--awaarien--

	
	

end;

	    local nearestDistance = 3.1;
		local vx, vy, vz = getWorldTranslation(g_currentMission.player.rootNode);
		
		local px, py, pz = getWorldTranslation(self.klapalewa); 
		local distance = Utils.vector3Length(px-vx, py-vy, pz-vz);	
		if distance < nearestDistance then
			self.przyklapiel = true; 
		else
			self.przyklapiel = false; 
		end;
		
		local rx, ry, rz = getWorldTranslation(self.klapaprawa); 
		local distance = Utils.vector3Length(rx-vx, ry-vy, rz-vz);	
		if distance < nearestDistance then
			self.przyklapiep = true; 
		else
			self.przyklapiep = false; 
		end;
		
		local ax, ay, az = getWorldTranslation(self.gardziel);
		local distance = Utils.vector3Length(ax-vx, ay-vy, az-vz);
		if distance < nearestDistance then
			self.przygardzielu = true;
		else
			self.przygardzielu = false;
		end;
		
		local sx, sy, sz = getWorldTranslation(self.klapach); 
		local distance = Utils.vector3Length(sx-vx, sy-vy, sz-vz);	
		if distance < nearestDistance then
			self.przyklapiech = true; 
		else
			self.przyklapiech = false; 
		end;
		
		local tx, ty, tz = getWorldTranslation(self.klapak); 
		local distance = Utils.vector3Length(tx-vx, ty-vy, tz-vz);	
		if distance < nearestDistance then
			self.przyklapiek = true; 
		else
			self.przyklapiek = false; 
		end;
		

		local fx, fy, fz = getWorldTranslation(self.klapalewa); 
		local distance = Utils.vector3Length(fx-vx, fy-vy, fz-vz);	
		if distance < nearestDistance then
			self.klapag = true; 
		else
			self.klapag = false; 
		end;
		

			local ax, ay, az = getWorldTranslation(self.klapas);
		local distance = Utils.vector3Length(ax-vx, ay-vy, az-vz);
		if distance < nearestDistance then
			self.przyklapies = true;
		else
			self.przyklapies = false;
		end;

		local gx, gy, gz = getWorldTranslation(self.klapalewa); 
		local distance = Utils.vector3Length(gx-vx, gy-vy, gz-vz);	
		if distance < nearestDistance then
			self.siecz = true; 
		else
			self.siecz = false; 
		end;
		local ix, iy, iz = getWorldTranslation(self.klapalewa); 
		local distance = Utils.vector3Length(ix-vx, iy-vy, iz-vz);	
		if distance < nearestDistance then
			self.drzwi = true; 
		else
			self.drzwi = false; 
		end;
	if self.isEntered then
	if InputBinding.isPressed(InputBinding.dogory) then
				self:setAnimationTime(22, self.animationParts[22].offSet);
			else
				self:setAnimationTime(22, self.animationParts[22].animDuration);
			end;
if InputBinding.isPressed(InputBinding.nadol) then
				self:setAnimationTime(23, self.animationParts[23].offSet);
			else
				self:setAnimationTime(23, self.animationParts[23].animDuration);
			end;
		end;

--animacje-----
 	if self.isEntered then
	if InputBinding.hasEvent(InputBinding.RURAz058) then
			if self.animationParts[1].clipEndTime then
				self:setAnimationTime(1, self.animationParts[1].offSet);
			elseif self.animationParts[1].clipStartTime then
				self:setAnimationTime(1, self.animationParts[1].animDuration);
			end;
		end;
	end;
if self.siecz then
	if self.animationParts[17].clipStartTime then
			g_currentMission:addExtraPrintText(string.format("%s: Rozloz Sieczkarnie", InputBinding.getKeyNamesOfDigitalAction(InputBinding.siecz)));
		else
			g_currentMission:addExtraPrintText(string.format("%s: Zloz Sieczkarnie", InputBinding.getKeyNamesOfDigitalAction(InputBinding.siecz)));
		end;
	end;
if self.drzwi then
	if self.animationParts[18].clipStartTime then
			g_currentMission:addExtraPrintText(string.format("%s: Otworz drzwi", InputBinding.getKeyNamesOfDigitalAction(InputBinding.drzwi)));
		else
			g_currentMission:addExtraPrintText(string.format("%s: Zamknij drzwi", InputBinding.getKeyNamesOfDigitalAction(InputBinding.drzwi)));
		end;
	end;
	if self:getIsActiveForSound() then
	if self.isEntered then
 	if InputBinding.isPressed(InputBinding.GARDZIELUP) then
               self:setAnimationTime(2, self.animationParts[2].currentPosition+(self.animationParts[2].offSet+dt), false);
           elseif InputBinding.isPressed(InputBinding.GARDZIELDOWN) then
               self:setAnimationTime(2, self.animationParts[2].currentPosition-(self.animationParts[2].offSet+dt), false);
        end;
        end;
        	
if self.isEntered then
if InputBinding.isPressed(InputBinding.otworz) then
               self:setAnimationTime(19, self.animationParts[19].currentPosition+(self.animationParts[19].offSet+dt), false);
           elseif InputBinding.isPressed(InputBinding.zamknij) then
               self:setAnimationTime(19, self.animationParts[19].currentPosition-(self.animationParts[19].offSet+dt), false);
        end;
if InputBinding.isPressed(InputBinding.MUCARNIAminus) then
               self:setAnimationTime(24, self.animationParts[24].currentPosition+(self.animationParts[24].offSet+dt), false);
           elseif InputBinding.isPressed(InputBinding.MUCARNIAplus) then
               self:setAnimationTime(24, self.animationParts[24].currentPosition-(self.animationParts[24].offSet+dt), false);
        end;
        	if InputBinding.hasEvent(InputBinding.KLEPISKO) then
			if self.animationParts[14].clipEndTime then
				self:setAnimationTime(14, self.animationParts[14].offSet);
			elseif self.animationParts[14].clipStartTime then
				self:setAnimationTime(14, self.animationParts[14].animDuration);
			end;
		end;
	if InputBinding.hasEvent(InputBinding.camera) then
			if self.animationParts[20].clipEndTime then
				self:setAnimationTime(20, self.animationParts[20].offSet);
			elseif self.animationParts[20].clipStartTime then
				self:setAnimationTime(20, self.animationParts[20].animDuration);
			end;
		end;
if InputBinding.isPressed(InputBinding.przod22) then
               self:setAnimationTime(21, self.animationParts[21].currentPosition+(self.animationParts[21].offSet+dt), false);
           elseif InputBinding.isPressed(InputBinding.tyl22) then
               self:setAnimationTime(21, self.animationParts[21].currentPosition-(self.animationParts[21].offSet+dt), false);
        end;
       end;
      end;
        if self.przyklapiech then
		if InputBinding.hasEvent(InputBinding.KLAPACH) then
			if self.animationParts[3].clipEndTime then
				self:setAnimationTime(3, self.animationParts[3].offSet);
			elseif self.animationParts[3].clipStartTime then
				self:setAnimationTime(3, self.animationParts[3].animDuration);
			end;
		end;
		end;
		if self.przyklapies then
			if InputBinding.hasEvent(InputBinding.KLAPAS) then
			if self.animationParts[12].clipEndTime then
				self:setAnimationTime(12, self.animationParts[12].offSet);
			elseif self.animationParts[12].clipStartTime then
				self:setAnimationTime(12, self.animationParts[12].animDuration);
			end;
		end;
		end;
		if self.przyklapiel then
		if InputBinding.hasEvent(InputBinding.KLEWA) then
			if self.animationParts[4].clipEndTime then
				self:setAnimationTime(4, self.animationParts[4].offSet);
			elseif self.animationParts[4].clipStartTime then
				self:setAnimationTime(4, self.animationParts[4].animDuration);
			end;
		end;
		end;
		if self.przyklapiep then
		if InputBinding.hasEvent(InputBinding.KPRAWA) then
			if self.animationParts[5].clipEndTime then
				self:setAnimationTime(5, self.animationParts[5].offSet);
			elseif self.animationParts[5].clipStartTime then
				self:setAnimationTime(5, self.animationParts[5].animDuration);
			end;
		end;
		end;
		if self.przyklapiek then
 	if InputBinding.hasEvent(InputBinding.KLAPAK) then
			if self.animationParts[6].clipEndTime then
				self:setAnimationTime(6, self.animationParts[6].offSet);
			elseif self.animationParts[6].clipStartTime then
				self:setAnimationTime(6, self.animationParts[6].animDuration);
			end;
		end;
		end;
		if self:getIsActiveForSound() then
			if self.isEntered then
			if InputBinding.hasEvent(InputBinding.HEDERg) then
			if self.animationParts[11].clipEndTime then
				self:setAnimationTime(11, self.animationParts[11].offSet);
				self.sound1 = false;
			elseif self.animationParts[11].clipStartTime then
				self:setAnimationTime(11, self.animationParts[11].animDuration);
				self.sound1 = true;
			end;
		end;
		 end;
	      end;

if self.isEntered or self.klapag then
 	if InputBinding.hasEvent(InputBinding.grzeg) then
             		if self.animationParts[13].clipEndTime then
				self:setAnimationTime(13, self.animationParts[13].offSet);
			elseif self.animationParts[13].clipStartTime then
				self:setAnimationTime(13, self.animationParts[13].animDuration);
			end;
        end;
end;
		  if not self.isThreshing then
				self:setAnimationTime(10, self.animationParts[10].offSet);
			else
				self:setAnimationTime(10, self.animationParts[10].animDuration);
			end;
        	if self.przygardzielu then
	if InputBinding.hasEvent(InputBinding.NAPRAW) then
	 self.zapchany = 0
	 self.psucie = false;
		end;
	end;
	if self.isEntered and self.isMotorStarted then
	if self.animationParts[1].clipStartTime then
			g_currentMission:addExtraPrintText(string.format("%s: Rozloz Rure", InputBinding.getKeyNamesOfDigitalAction(InputBinding.RURAz058)));
		else
			g_currentMission:addExtraPrintText(string.format("%s: Zloz Rure", InputBinding.getKeyNamesOfDigitalAction(InputBinding.RURAz058)));
		end;
	end;
if self.klapag then
	if self.animationParts[13].clipStartTime then
			g_currentMission:addExtraPrintText(string.format("%s: Rozloz klapa zbiornik", InputBinding.getKeyNamesOfDigitalAction(InputBinding.grzeg)));
		else
			g_currentMission:addExtraPrintText(string.format("%s: Zloz klapa zbiornik", InputBinding.getKeyNamesOfDigitalAction(InputBinding.grzeg)));
		end;
	end;
		if self.przyklapiep then
	if self.animationParts[5].clipStartTime then
			g_currentMission:addExtraPrintText(string.format("%s: Otworz Klape", InputBinding.getKeyNamesOfDigitalAction(InputBinding.KPRAWA)));
		else
			g_currentMission:addExtraPrintText(string.format("%s: Zamknij Klape", InputBinding.getKeyNamesOfDigitalAction(InputBinding.KPRAWA)));
		end;
	end;
		if self.przyklapiel then
	if self.animationParts[4].clipStartTime then
			g_currentMission:addExtraPrintText(string.format("%s: Otworz Klape", InputBinding.getKeyNamesOfDigitalAction(InputBinding.KLEWA)));
		else
			g_currentMission:addExtraPrintText(string.format("%s: Zamknij Klape", InputBinding.getKeyNamesOfDigitalAction(InputBinding.KLEWA)));
		end;
	end;
		if self.przyklapiech then
	if self.animationParts[3].clipStartTime then
			g_currentMission:addExtraPrintText(string.format("%s: Otworz Klape", InputBinding.getKeyNamesOfDigitalAction(InputBinding.KLAPACH)));
		else
			g_currentMission:addExtraPrintText(string.format("%s: Zamknij Klape", InputBinding.getKeyNamesOfDigitalAction(InputBinding.KLAPACH)));
		end;
	end;
		if self.przyklapiek then
if self.animationParts[6].clipStartTime then
			g_currentMission:addExtraPrintText(string.format("%s: Otworz Klape", InputBinding.getKeyNamesOfDigitalAction(InputBinding.KLAPAK)));
		else
			g_currentMission:addExtraPrintText(string.format("%s: Zamknij Klape", InputBinding.getKeyNamesOfDigitalAction(InputBinding.KLAPAK)));
		end;
	end;
	if self.przygardzielu then
if self.psucie then
			g_currentMission:addExtraPrintText(string.format("%s: Wyczysz Heder", InputBinding.getKeyNamesOfDigitalAction(InputBinding.NAPRAW)));
	end;
	end;
   	if self.przyklapies then
if self.animationParts[12].clipStartTime then
			g_currentMission:addExtraPrintText(string.format("%s: Otworz Klape", InputBinding.getKeyNamesOfDigitalAction(InputBinding.KLAPAS)));
		else
			g_currentMission:addExtraPrintText(string.format("%s: Zamknij Klape", InputBinding.getKeyNamesOfDigitalAction(InputBinding.KLAPAS)));
		end;
	end;


if self.isEntered then
if self.setAnimationTime ~= nil then
 if self.isMotorStarted then
        self:setAnimationTime(8, 1);
   if self.isThreshing then
        self:setAnimationTime(7, 1);
  if not self.animationParts[11].clipStartTime then
        self:setAnimationTime(9, 1);
        else
        self:setAnimationTime(9, 0);
        end;
   else
        self:setAnimationTime(7, 0);
        self:setAnimationTime(9, 0);
    end;  
 else
        self:setAnimationTime(8, 0);
        self:setAnimationTime(7, 0);
        self:setAnimationTime(9, 0);
 end;
	if self.isThreshing then
	 self:setAnimationTime(15, 1);
	 else
	 self:setAnimationTime(15, 0);
	end;

	if self.czas4 >= 1500 then
		self.animationParts[7].clipSpeed = 2;
		self.animationParts[9].clipSpeed = 2;
  	else
		self.animationParts[7].clipSpeed = 0.17;
		self.animationParts[9].clipSpeed = 0.17;
	end;

	if self.isThreshing and self.chopperActivated then
		self:setAnimationTime(16, 1);
	 else
		self:setAnimationTime(16, 0);
	end;
	if self.czas4 >= 2000 and self.isThreshing and self.chopperActivated then
		self.animationParts[16].clipSpeed = 1.8;
	 else
		self.animationParts[16].clipSpeed = 0.1;
	end;

if self.czas4 >= 2000 then
  self.animationParts[15].clipSpeed = self.speedbujanie;
  else
  self.animationParts[15].clipSpeed = 0.9;
end;
end;

if self.isThreshing then
    		if InputBinding.isPressed(InputBinding.MUCARNIAplus) then
     			if self.speedbujanie < 3.8 then
      				self.speedbujanie = self.speedbujanie+0.02;
	   		end;
	  	elseif InputBinding.isPressed(InputBinding.MUCARNIAminus) then
	    		if self.speedbujanie > 1.1 then
      				self.speedbujanie = self.speedbujanie-0.02;
      			end;
      		end;
  	end;
end;
if self.isEntered then
if self.numAttachedCutters > 0 then
if self.animationParts[11].clipEndTime then
if self.czas4 >= 2200 then
	if not self.cutterSoundPlaying then
		playSample(self.cutterSound, 0, 1, 0);
		self.cutterSoundPlaying = true;
		end;
	else
		stopSample(self.cutterSound);
		self.cutterSoundPlaying = false;
	end;
	else
		stopSample(self.cutterSound);
		self.cutterSoundPlaying = false;
	end;
	else
		stopSample(self.cutterSound);
		self.cutterSoundPlaying = false;
	end;
	else
		stopSample(self.cutterSound);
		self.cutterSoundPlaying = false;
	end;
if self.isEntered then	
if self.currentPipeState ~= 1 then
    if self.animationParts[1].clipEndTime then
      if self.pipeIsUnloading == false then
	if not self.cutter2SoundPlaying then
			playSample(self.cutter2Sound, 0, 1, 0);
			self.cutter2SoundPlaying = true;
	end;
	else
		stopSample(self.cutter2Sound);
		self.cutter2SoundPlaying = false;
	end;
	else
		stopSample(self.cutter2Sound);
		self.cutter2SoundPlaying = false;
	end;
	else
		stopSample(self.cutter2Sound);
		self.cutter2SoundPlaying = false;
	end;
	else
		stopSample(self.cutter2Sound);
		self.cutter2SoundPlaying = false;
	end;

if self.isEntered then
	if self.pipeIsUnloading == true then
		if not self.cutter3SoundPlaying then
			playSample(self.cutter3Sound, 0, 1, 0);
			self.cutter3SoundPlaying = true;
			stopSample(self.cutter2Sound);
			self.cutter2SoundPlaying = false;
	end;
	elseif self.pipeIsUnloading == false then
			stopSample(self.cutter3Sound);
			self.cutter3SoundPlaying = false;
	
	end;
end;
 --------------------ANIMACJE KONIEC----------------------



    if self.kogutAnz > 0 then
      if self.kogutAn then
        for i=1, self.kogutAnz do
          rotate(self.kogut[i].rotNode, 0, dt*self.kogut[i].speed, 0);
        end;
      end;
    end;




	setVisibility(self.lusterka, self.lusterkaActive);
	setVisibility(self.halogeny, self.halogenyActive);
	
   	setVisibility(self.kontrolka1, self.kontrolka1on);
   	setVisibility(self.kontrolka2, self.kontrolka2on);

   	setVisibility(self.kontrolka4, self.kontrolka4on);
   	setVisibility(self.kontrolka5, self.kontrolka5on);

	


setVisibility(self.halogen2, self.halogen2Active);
setVisibility(self.kierunek, self.kierunekActive);
setVisibility(self.kierunek2, self.kierunek2Active); 
     
    	if self:getIsActive() then			
		self.setHydraulicTime = 30;	
	end;
	
		
	if self.setHydraulicTime > 0 then
		for k,v in pairs(self.hydraulics) do 
			self:setHydraulicDirection(k);
		end;
		self.setHydraulicTime = self.setHydraulicTime - 1;
	end;	


	if self.isMotorStarted and self:getIsActiveForSound() and self.isEntered then
	
	    if self.motor.speedLevel ~= 0 then
			
            if InputBinding.isPressed(InputBinding.ACCELERATE) then
		        if self.motor.maxRpm[self.motor.speedLevel] <= (self.motorMaxRpmLimit[3] - 10) then
		            self.motor.maxRpm[self.motor.speedLevel] = self.motor.maxRpm[self.motor.speedLevel] + 10;
			    end;
		    elseif InputBinding.isPressed(InputBinding.DECELERATE) then
		        if self.motor.maxRpm[self.motor.speedLevel] >= 10 then
			        self.motor.maxRpm[self.motor.speedLevel] = self.motor.maxRpm[self.motor.speedLevel] - 10;
			    end;
	    	end;
				
		else
			
            if InputBinding.isPressed(InputBinding.ACCELERATE) then
		        if self.motor.maxRpm[3] <= (self.motorMaxRpmLimit[3] - 10) then
		            self.motor.maxRpm[3] = self.motor.maxRpm[3] + 10;
			    end;
		    elseif InputBinding.isPressed(InputBinding.DECELERATE) then
		        if self.motor.maxRpm[3] >= 10 then
			            self.motor.maxRpm[3] = self.motor.maxRpm[3] - 10;
			    end;
	    	end;
			
	    end;
		
	end;
 	if self.rotationPartpedalhamulca ~= nil then
		local x, y, z = getRotation(self.rotationPartpedalhamulca.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartpedalhamulca.maxRot, self.rotationPartpedalhamulca.minRot, 3, self.rotationPartpedalhamulca.rotTime, dt, not self.rotationMaxpedalhamulca);
		setRotation(self.rotationPartpedalhamulca.node, unpack(newRot));
	end;


	 if self.rotationPartpret ~= nil then
		   local x, y, z = getRotation(self.rotationPartpret.node);
		   local rot = {x,y,z};
		   local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartpret.maxRot, self.rotationPartpret.minRot, 3, self.rotationPartpret.rotTime, dt, not self.rotationMaxpret);
		   setRotation(self.rotationPartpret.node, unpack(newRot));
        end;

	
	
	
    if self.isMotorStarted then
    if self.dodaniegazu and self:getIsActiveForSound() and self:getIsActiveForSound() then
       if not self.hor1nPlaying then
            playSample(self.hor1nSoundId, 1, 3, 3);
            self.hor1nPlaying = true;
        end;
    else
        if self.hor1nPlaying then
            stopSample(self.hor1nSoundId);
            self.hor1nPlaying = false;
        end;
    end;
    end;
		  if self.isEntered then
           if self.gaz then
      if not self.mower25SoundEnabled and self:getIsActiveForSound() then
                setSamplePitch(self.mower25Sound, self.mower25SoundPitchOffset);
                playSample(self.mower25Sound, 0, self.mower25SoundVolume, 0);
                self.mower25SoundEnabled = true;
            end;
        else
            if self.mower25SoundEnabled then
                stopSample(self.mower25Sound);
                self.mower25SoundEnabled = false;
            end;
        end;
        end;
       if self.isMotorStarted then
         if self.odjeciegazu and self:getIsActiveForSound() and self:getIsActiveForSound() then
       if not self.hor12nPlaying then
            playSample(self.hor12nSoundId, 1, 3, 3);
            self.hor12nPlaying = true;
        end;
    else
        if self.hor12nPlaying then
            stopSample(self.hor12nSoundId);
            self.hor12nPlaying = false;
        end;
    end;


---------------------------------------sypanie----------------------------
if not self.gaz then
if self.isEntered then
if self.isMotorStarted then
    if self.setMode == 3 and self:getIsActiveForSound() and self:getIsActiveForSound() then
       if not self.startsypaniePlaying then
            playSample(self.startsypanieSoundId, 1, 3, 3);
            self.startsypaniePlaying = true;
        end;
    else
        if self.startsypaniePlaying then
            stopSample(self.startsypanieSoundId);
            self.startsypaniePlaying = false;
        end;
    end;
    end;
		  if self.isEntered then
           if self.dzialasypanie2 == true then
      if not self.sypaniedzialaSoundEnabled and self:getIsActiveForSound() then
                setSamplePitch(self.sypaniedzialaSound, self.sypaniedzialaSoundPitchOffset);
                playSample(self.sypaniedzialaSound, 0, self.sypaniedzialaSoundVolume, 0);
                self.sypaniedzialaSoundEnabled = true;
            end;
        else
            if self.sypaniedzialaSoundEnabled then
                stopSample(self.sypaniedzialaSound);
                self.sypaniedzialaSoundEnabled = false;
            end;
        end;
        end;
       if self.isMotorStarted then
         if self.koniec == false and self:getIsActiveForSound() and self:getIsActiveForSound() then
       if not self.koniecsypaniePlaying then
            playSample(self.koniecsypanieSoundId, 1, 3, 3);
            self.koniecsypaniePlaying = true;
        end;
    else
        if self.koniecsypaniePlaying then
            stopSample(self.koniecsypanieSoundId);
            self.koniecsypaniePlaying = false;
        end;
    end;
end;

if self.setMode == 3 then
    if self.czas2 >= -1 then
	self.czas2 = self.czas2 +(dt/1);
    end;
    else
    if self.czas2 >= 1000 then
    self.czas2 = 1260;
    else
    self.czas2 = 0;
    end;
    end;
    if self.koniec == false then
    if self.czas2 ~= 0 then
	self.czas2 = 0;
	end;
	else
	if self.czas2 == 0 then
	self.czas2 = 0;
    end;
    end;
	if self.czas2 >= 1260 then
    self.dzialasypanie2 = true;
    else
    self.dzialasypanie2 = false;
    end;
end;
end;
-------------------------------------sypanieend------------------------------------

	  if Input.isKeyPressed(Input.KEY_f2) then
    self.dodaniegazu = true;
    self.odjeciegazu = false;

    else

    self.dodaniegazu = false;
    end;
    if InputBinding.hasEvent(InputBinding.GAZDOWN) then
     if self.gaz then
      self.odjeciegazu = true;
    end;
    end;
    if Input.isKeyPressed(Input.KEY_f2) then
    if self.czas4 >= -1 then
	self.czas4 = self.czas4 +(dt/1);
    end;
    else
    if self.czas4 >= 2000 then
    self.czas4 = 2800;
    else
    self.czas4 = 0;
    end;
    end;
    if Input.isKeyPressed(Input.KEY_f3) then
    if self.czas4 ~= 0 then
	self.czas4 = 0;
	end;
	else
	if self.czas4 == 0 then
	self.czas4 = 0;
    end;
    end;
    if self.czas4 >= 2600 then
    self.gaz = true
    else
    self.gaz = false;
    end;

	end;


	
	 if self.isEntered and self.isMotorStarted then 
   if Input.isKeyPressed(Input.KEY_pageup) or Input.isKeyPressed(Input.KEY_KP_8) or Input.isKeyPressed(Input.KEY_KP_6) or Input.isKeyPressed(Input.KEY_KP_4) or Input.isKeyPressed(Input.KEY_KP_5) or Input.isKeyPressed(Input.KEY_KP_9) or Input.isKeyPressed(Input.KEY_KP_plus) or Input.isKeyPressed(Input.KEY_KP_7) or Input.isKeyPressed(Input.KEY_KP_minus) or Input.isKeyPressed(Input.KEY_KP_pagedown) then
        if not self.odtwarzanie_dzwieku then
            playSample(self.skretSoundId, 0, 1, 0);
            self.odtwarzanie_dzwieku = true;
        end;

    	else

        if self.odtwarzanie_dzwieku then
            stopSample(self.skretSoundId);
            self.odtwarzanie_dzwieku = false;
        end;
    end;
	 end;
	
	
	if self.isEntered then
     if self.isMotorStarted then
    	 if self.lastSpeed*3600 > 13 then
       if not self.hor21nPlaying then
            playSample(self.hor21nSoundId, 1, 3, 3);
            self.hor21nPlaying = true;
        end;
        else
        if self.hor21nPlaying then
            stopSample(self.hor21nSoundId);
            self.hor21nPlaying = false;
        end;
    end;
    else
        if self.hor21nPlaying then
            stopSample(self.hor21nSoundId);
            self.hor21nPlaying = false;
        end;
    end;
   else
        if self.hor21nPlaying then
            stopSample(self.hor21nSoundId);
            self.hor21nPlaying = false;
        end;
        end

 	  if self.isEntered then
          if self.currentPipeState == 2 then
            		if self.animationParts[1].clipEndTime then
            		  if self.pipeParticleActivated then
      if not self.mowe2r25SoundEnabled and self:getIsActiveForSound() then
                setSamplePitch(self.mowe2r25Sound, self.mowe2r25SoundPitchOffset);
                playSample(self.mowe2r25Sound, 0, self.mowe2r25SoundVolume, 0);
                self.mowe2r25SoundEnabled = true;
            end;
        else
            if self.mowe2r25SoundEnabled then
                stopSample(self.mowe2r25Sound);
                self.mowe2r25SoundEnabled = false;
            end;
            end;
       else
            if self.mowe2r25SoundEnabled then
                stopSample(self.mowe2r25Sound);
                self.mowe2r25SoundEnabled = false;
            end;
        end;
            else
            if self.mowe2r25SoundEnabled then
                stopSample(self.mowe2r25Sound);
                self.mowe2r25SoundEnabled = false;
            end;
            end;
        else
            if self.mowe2r25SoundEnabled then
                stopSample(self.mowe2r25Sound);
                self.mowe2r25SoundEnabled = false;
            end;
        end;
  	if Input.isKeyPressed(Input.KEY_1) or Input.isKeyPressed(Input.KEY_2) or Input.isKeyPressed(Input.KEY_3) then
	  self.rotationMaxsprzeglo5 = true
	  else
	  self.rotationMaxsprzeglo5 = false;
	  end;

     if self.hamuj then
 	    self.rotationMaxsprzeglo6 = true;
    else
 	    self.rotationMaxsprzeglo6 = false;
 	end;

	  
if self.motor.speedLevel == 0 then
            self.rotationMaxtet2 = false;
            self.rotationMaxtet3 = false;
            self.rotationMaxtet1 = false;
            self.rotationMaxtetr = false;
 elseif self.motor.speedLevel == 1 then
    	    self.rotationMaxtet1 = true;
            self.rotationMaxtet2 = false;
            self.rotationMaxtet3 = false;
            self.rotationMaxtetr = false;
 elseif self.motor.speedLevel == 2 then
            self.rotationMaxtet2 = true;
            self.rotationMaxtet1 = false;
            self.rotationMaxtet3 = false;
            self.rotationMaxtetr = false;
 elseif self.motor.speedLevel == 3 then
   	        self.rotationMaxtet3 = true;
            self.rotationMaxtet2 = false;
            self.rotationMaxtet1 = false;
			self.rotationMaxtetr = false;  			  
 end;
 if self.isEntered then
if Input.isKeyPressed(Input.KEY_w) then
   self.rotationMaxtetr = false;
    self.rotationMaxtet3 = true;
elseif Input.isKeyPressed(Input.KEY_s) then 
    self.rotationMaxtetr = true;
end; 
end;   

--||--wajchy--||--
		  --------------------heder gora dol------------------------
	      if self.rotationPartwajcha ~= nil then
		   local x, y, z = getRotation(self.rotationPartwajcha.node);
		   local rot = {x,y,z};
		   local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartwajcha.maxRot, self.rotationPartwajcha.minRot, 3, self.rotationPartwajcha.rotTime, dt, not self.rotationMaxwajcha);
		   setRotation(self.rotationPartwajcha.node, unpack(newRot));
        end;
          if self.rotationPartwajcha2 ~= nil then
		   local x, y, z = getRotation(self.rotationPartwajcha2.node);
		   local rot = {x,y,z};
		   local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartwajcha2.maxRot, self.rotationPartwajcha2.minRot, 3, self.rotationPartwajcha2.rotTime, dt, not self.rotationMaxwajcha2);
		   setRotation(self.rotationPartwajcha2.node, unpack(newRot));
        end;
        -----------------------motowidla gora dol-------------------------
         if self.rotationPartwajcha3 ~= nil then
		   local x, y, z = getRotation(self.rotationPartwajcha3.node);
		   local rot = {x,y,z};
		   local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartwajcha3.maxRot, self.rotationPartwajcha3.minRot, 3, self.rotationPartwajcha3.rotTime, dt, not self.rotationMaxwajcha3);
		   setRotation(self.rotationPartwajcha3.node, unpack(newRot));
        end;
         if self.rotationPartwajcha4 ~= nil then
		   local x, y, z = getRotation(self.rotationPartwajcha4.node);
		   local rot = {x,y,z};
		   local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartwajcha4.maxRot, self.rotationPartwajcha4.minRot, 3, self.rotationPartwajcha4.rotTime, dt, not self.rotationMaxwajcha4);
		   setRotation(self.rotationPartwajcha4.node, unpack(newRot));
        end;
        -------------------------wariator----------------------------
         if self.rotationPartwajcha5 ~= nil then
		   local x, y, z = getRotation(self.rotationPartwajcha5.node);
		   local rot = {x,y,z};
		   local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartwajcha5.maxRot, self.rotationPartwajcha5.minRot, 3, self.rotationPartwajcha5.rotTime, dt, not self.rotationMaxwajcha5);
		   setRotation(self.rotationPartwajcha5.node, unpack(newRot));
        end;
         if self.rotationPartwajcha6 ~= nil then
		   local x, y, z = getRotation(self.rotationPartwajcha6.node);
		   local rot = {x,y,z};
		   local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartwajcha6.maxRot, self.rotationPartwajcha6.minRot, 3, self.rotationPartwajcha6.rotTime, dt, not self.rotationMaxwajcha6);
		   setRotation(self.rotationPartwajcha6.node, unpack(newRot));
        end;
        -------------------------------motowidla szybciej wolniej-------------------
          if self.rotationPartwajcha7 ~= nil then
		   local x, y, z = getRotation(self.rotationPartwajcha7.node);
		   local rot = {x,y,z};
		   local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartwajcha7.maxRot, self.rotationPartwajcha7.minRot, 3, self.rotationPartwajcha7.rotTime, dt, not self.rotationMaxwajcha7);
		   setRotation(self.rotationPartwajcha7.node, unpack(newRot));
        end;
         if self.rotationPartwajcha8 ~= nil then
		   local x, y, z = getRotation(self.rotationPartwajcha8.node);
		   local rot = {x,y,z};
		   local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartwajcha8.maxRot, self.rotationPartwajcha8.minRot, 3, self.rotationPartwajcha8.rotTime, dt, not self.rotationMaxwajcha8);
		   setRotation(self.rotationPartwajcha8.node, unpack(newRot));
        end;
        ------------------------------------------motowidla przod tyl----------------------------------
         if self.rotationPartwajcha9 ~= nil then
		   local x, y, z = getRotation(self.rotationPartwajcha9.node);
		   local rot = {x,y,z};
		   local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartwajcha9.maxRot, self.rotationPartwajcha9.minRot, 3, self.rotationPartwajcha9.rotTime, dt, not self.rotationMaxwajcha9);
		   setRotation(self.rotationPartwajcha9.node, unpack(newRot));
        end;
         if self.rotationPartwajcha10 ~= nil then
		   local x, y, z = getRotation(self.rotationPartwajcha10.node);
		   local rot = {x,y,z};
		   local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartwajcha10.maxRot, self.rotationPartwajcha10.minRot, 3, self.rotationPartwajcha10.rotTime, dt, not self.rotationMaxwajcha10);
		   setRotation(self.rotationPartwajcha10.node, unpack(newRot));
        end;
----
  if self.rotationParttet1 ~= nil then
		   local x, y, z = getRotation(self.rotationParttet1.node);
		   local rot = {x,y,z};
		   local newRot = Utils.getMovedLimitedValues(rot, self.rotationParttet1.maxRot, self.rotationParttet1.minRot, 3, self.rotationParttet1.rotTime, dt, not self.rotationMaxtet1);
		   setRotation(self.rotationParttet1.node, unpack(newRot));
        end;
       if self.rotationParttet2 ~= nil then
		   local x, y, z = getRotation(self.rotationParttet2.node);
		   local rot = {x,y,z};
		   local newRot = Utils.getMovedLimitedValues(rot, self.rotationParttet2.maxRot, self.rotationParttet2.minRot, 3, self.rotationParttet2.rotTime, dt, not self.rotationMaxtet2);
		   setRotation(self.rotationParttet2.node, unpack(newRot));
        end;
       if self.rotationParttet3 ~= nil then
		   local x, y, z = getRotation(self.rotationParttet3.node);
		   local rot = {x,y,z};
		   local newRot = Utils.getMovedLimitedValues(rot, self.rotationParttet3.maxRot, self.rotationParttet3.minRot, 3, self.rotationParttet3.rotTime, dt, not self.rotationMaxtet3);
		   setRotation(self.rotationParttet3.node, unpack(newRot));
        end;
       if self.rotationParttetr ~= nil then
		   local x, y, z = getRotation(self.rotationParttetr.node);
		   local rot = {x,y,z};
		   local newRot = Utils.getMovedLimitedValues(rot, self.rotationParttetr.maxRot, self.rotationParttetr.minRot, 3, self.rotationParttetr.rotTime, dt, not self.rotationMaxtetr);
		   setRotation(self.rotationParttetr.node, unpack(newRot));
        end;
       ------- 
        	if self.rotationPartabl1 ~= nil then
		   local x, y, z = getRotation(self.rotationPartabl1.node);
		   local rot = {x,y,z};
		   local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartabl1.maxRot, self.rotationPartabl1.minRot, 3, self.rotationPartabl1.rotTime, dt, not self.rotationMaxabl1);
		   setRotation(self.rotationPartabl1.node, unpack(newRot));
        end;
        if self.rotationPartabl2 ~= nil then
		   local x, y, z = getRotation(self.rotationPartabl2.node);
		   local rot = {x,y,z};
		   local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartabl2.maxRot, self.rotationPartabl2.minRot, 3, self.rotationPartabl2.rotTime, dt, not self.rotationMaxabl2);
		   setRotation(self.rotationPartabl2.node, unpack(newRot));
        end;
        if self.rotationParthidra1 ~= nil then
		   local x, y, z = getRotation(self.rotationParthidra1.node);
		   local rot = {x,y,z};
		   local newRot = Utils.getMovedLimitedValues(rot, self.rotationParthidra1.maxRot, self.rotationParthidra1.minRot, 3, self.rotationParthidra1.rotTime, dt, not self.rotationMaxhidra1);
		   setRotation(self.rotationParthidra1.node, unpack(newRot));
        end;
        if self.rotationParthidra2 ~= nil then
		   local x, y, z = getRotation(self.rotationParthidra2.node);
		   local rot = {x,y,z};
		   local newRot = Utils.getMovedLimitedValues(rot, self.rotationParthidra2.maxRot, self.rotationParthidra2.minRot, 3, self.rotationParthidra2.rotTime, dt, not self.rotationMaxhidra2);
		   setRotation(self.rotationParthidra2.node, unpack(newRot));
        end;
         if self.rotationParthidra3 ~= nil then
		   local x, y, z = getRotation(self.rotationParthidra3.node);
		   local rot = {x,y,z};
		   local newRot = Utils.getMovedLimitedValues(rot, self.rotationParthidra3.maxRot, self.rotationParthidra3.minRot, 3, self.rotationParthidra3.rotTime, dt, not self.rotationMaxhidra3);
		   setRotation(self.rotationParthidra3.node, unpack(newRot));
        end;
         if self.rotationParthidra31 ~= nil then
		   local x, y, z = getRotation(self.rotationParthidra31.node);
		   local rot = {x,y,z};
		   local newRot = Utils.getMovedLimitedValues(rot, self.rotationParthidra31.maxRot, self.rotationParthidra31.minRot, 3, self.rotationParthidra31.rotTime, dt, not self.rotationMaxhidra31);
		   setRotation(self.rotationParthidra31.node, unpack(newRot));
        end;
        	if self.rotationPartsprzeglo5 ~= nil then
		local x, y, z = getRotation(self.rotationPartsprzeglo5.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartsprzeglo5.maxRot, self.rotationPartsprzeglo5.minRot, 3, self.rotationPartsprzeglo5.rotTime, dt, not self.rotationMaxsprzeglo5);
		setRotation(self.rotationPartsprzeglo5.node, unpack(newRot));
	end;
		if self.rotationPartsprzeglo6 ~= nil then
		local x, y, z = getRotation(self.rotationPartsprzeglo6.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.rotationPartsprzeglo6.maxRot, self.rotationPartsprzeglo6.minRot, 3, self.rotationPartsprzeglo6.rotTime, dt, not self.rotationMaxsprzeglo6);
		setRotation(self.rotationPartsprzeglo6.node, unpack(newRot));
	end;

             if not self.animationParts[11].clipEndTime then
                   for cutter,implement in pairs(self.attachedCutters) do
                   cutter:onStopReel();
                   end;

			 elseif not self.animationParts[11].clipStartTime and not self.animationParts[10].clipStartTime then
			  if self.isThreshing then
			    for cutter,implement in pairs(self.attachedCutters) do
                cutter:onStartReel();
                end;

              end;
             end;

---wajcha wysypywania
 if self.currentPipeState ~= 1 then
		self.rotationMaxpedalhamulca = true;
	else
		self.rotationMaxpedalhamulca = false;
   	end;

    	if not self.gaz or not self.isEntered then
            if self.mower25SoundEnabled then
                stopSample(self.mower25Sound);
                self.mower25SoundEnabled = false;
            end;
        end;

 if self.dodaniegazu or self.gaz then
        self.rotationMaxpret = true
        elseif not self.gaz then
        self.rotationMaxpret = false;
        end;
      



end;	

function Z056:onLeave()
self.odjeciegazu = false;
self.acmilan99sActive = true;
self.acmilanrsActive = true;
self.acmilanosActive = true;
self.acmilano2sActive = true;
end;

function Z056:draw()
	if not self.info then
			setTextColor(0.25,0.25,0.25,0.9);
			setTextBold(true);
			renderText(0.8335, 0.18, 0.02, "0-Bizon info-pokaz");
		else	
			renderText(0.8335, 0.18, 0.02, "0-Bizon info-schowaj");
		end;

if self.isEntered and self.isMotorStarted then
	if self.animationParts[11].clipEndTime then
        g_currentMission:addExtraPrintText("Wcisnij K: 			Wylacz mlocarnie");
    else
	g_currentMission:addExtraPrintText("Wcisnij K: 			Wlacz mlocarnie ");
    end;

if self.animationParts[18].clipStartTime then
        g_currentMission:addExtraPrintText("Wcisnij 7: 			otworz drzwi");
    else
	g_currentMission:addExtraPrintText("Wcisnij 7: 			zamknij drzwi");
    end;

if self.animationParts[21].clipStartTime then
        g_currentMission:addExtraPrintText("Wcisnij Z: 			kamera srodek oddal");
    else
	g_currentMission:addExtraPrintText("Wcisnij X: 			kamera srodek przybliz");
    end;

if self.animationParts[19].clipStartTime then
        g_currentMission:addExtraPrintText("Przytrzymaj 5: 			Otworzo okno");
    else
	g_currentMission:addExtraPrintText("Przytrzymaj 6: 			Zamknij okno");
    end;

   if self.animationParts[24].clipStartTime then
          g_currentMission:addExtraPrintText("Przytrzymaj N: 			Mlucarnia oborty mniejsze");
    else
 	  g_currentMission:addExtraPrintText("Przytrzymaj M: 			Mlucarnia oborty wieksze");
    end;

if self.gaz then
          g_currentMission:addExtraPrintText("Wcisnij f3: 			Wylacz koszenie");
    else
 	  g_currentMission:addExtraPrintText("Przytrzymaj f2: 			Wlacz koszenie");
    end;

if self.setMode == 0 then
          g_currentMission:addExtraPrintText("Wcisnij f10: 			Sypanie szybkosc ()");
    elseif self.setMode == 1 then
 	  g_currentMission:addExtraPrintText("Wcisnij f10: 			Sypanie szybkosc (Poziom 1)");
 	elseif self.setMode == 2 then
 	  g_currentMission:addExtraPrintText("Wcisnij f10: 			Sypanie szybkosc (Poziom 2)");
	elseif self.setMode == 3 then
 	  g_currentMission:addExtraPrintText("Wcisnij f10: 			Sypanie szybkosc (Poziom 3)");
    end;
end;

	if self.info then
	    	self.hudInfoBaseOverlay:render();
			setTextBold(true);
			renderText(0.62, 0.84, 0.025, "-Bizon Zo56-");
			renderText(0.62, 0.815, 0.02, "Przycisk Z: Zapal");	
			renderText(0.62, 0.8, 0.02, "Przycisk Home: Kogut");			
			renderText(0.62, 0.785, 0.02, "Przycisk J: Mlocarnia");
			renderText(0.62, 0.77, 0.02, "Przycisk G: Heder");
			renderText(0.62, 0.755, 0.02, "Przyciski N/M: Klapa Zbiornika");			
			renderText(0.62, 0.74, 0.02, "Przycisk 7: Halogeny Przednie");
			renderText(0.62, 0.725, 0.02, "Przyciski +/-; Przyspieszacz Szybciej/Wolniej");
			renderText(0.62, 0.71, 0.02, "Przycisk PgDown: Heder - dol");
            renderText(0.62, 0.695, 0.02, "Przycisk PgUp: Heder - gora");
            renderText(0.62, 0.68, 0.02, "Przycisk B: Wysypywanie");
			renderText(0.62, 0.665, 0.02, "Potrzymaj f2 By Dodac Gazu");
			renderText(0.62, 0.65, 0.02, "Przycisk f3 Zdejmij Gaz");
			if self.animationParts[14].clipStartTime then
            renderText(0.62, 0.635, 0.02, "Przycisk f4 Skrec klepisko");
            else
            renderText(0.62, 0.635, 0.02, "Przycisk f4 Rozkrec klepisko");
            end
            renderText(0.62, 0.62, 0.02, "Przycisk Num 2: Awaryjne");
            renderText(0.62, 0.605, 0.02, "Przycisk Num 1/3: Migacze");
            renderText(0.62, 0.585, 0.025, "-Bizon Zo56-");
            if self.numAttachedCutters > 0 then
            renderText(0.62, 0.565, 0.025, "-Heder z056-");
            renderText(0.62, 0.55, 0.02, "Przyciski KP 4/6; Motowidla Wsun/Wysun");
            renderText(0.62, 0.535, 0.02, "Przyciski KP 7/9; Motowidla Szybciej/Wolniej");
            renderText(0.62, 0.52, 0.02, "Przyciski KP 8/5; Motowidla Wyzej/Nizej");
            renderText(0.62, 0.5, 0.025, "-Heder z056-");
            else
            renderText(0.62, 0.565, 0.025, "Heder Odczepiony"); 
			end;        

		end;

end;
function Z056:setHydraulicDirection(index)
	local hydraulic = self.hydraulics[index];

	if hydraulic.fixPoint ~= nil then
		local ax, ay, az = getWorldTranslation(hydraulic.node);
		local bx, by, bz = getWorldTranslation(hydraulic.fixPoint);
		local x, y, z = worldDirectionToLocal(getParent(hydraulic.node), bx-ax, by-ay, bz-az);
		local xUp, yUp, zUp = unpack(hydraulic.upVectors);
		setDirection(hydraulic.node, x, y, z, xUp, yUp, zUp);
		if hydraulic.punch ~= nil then
			local distance = Utils.vector3Length(ax-bx, ay-by, az-bz);
			setTranslation(hydraulic.punch, 0, 0, distance-hydraulic.punchDistance);
		end;
	end;
end;
function Z056:validateAttacherJoint(implement, jointDesc, dt)
   return true;
end;

function Z056:mouseEvent(posX, posY, isDown, isUp, button)
end;
function Z056:setVehicleRpmUp(dt, isActive)
	if self.saveMinRpm ~= 0 and self.motor ~= nil then
		if dt ~= nil then
			if isActive == true then
				self.motor.minRpm = math.max(self.motor.minRpm-(dt/2), -800);
			else
				self.motor.minRpm = math.min(self.motor.minRpm+(dt*2), self.saveMinRpm);
			end;
		else
			self.motor.minRpm = self.saveMinRpm;
		end;
		if self.isMotorStarted then
			local fuelUsed = 0.0000011*math.abs(self.motor.minRpm);
			self:setFuelFillLevel(self.fuelFillLevel-fuelUsed);
			g_currentMission.missionStats.fuelUsageTotal = g_currentMission.missionStats.fuelUsageTotal + fuelUsed;
			g_currentMission.missionStats.fuelUsageSession = g_currentMission.missionStats.fuelUsageSession + fuelUsed;
		end;
	end;
end;
function Z056:stopThreshing()


if self.aiThreshingz058Sound ~= nil then
			setVisibility(self.aiThreshingz058Sound, false);
		end;
if self.aiCutterSound ~= nil then
			setVisibility(self.aiCutterSound, false);
		end;
if self.aiThreshingmucarniaSound ~= nil then
			setVisibility(self.aiThreshingmucarniaSound, false);
		end;
		
end;
function Z056:onDeactivate()
	Utils.setEmittingState(self.startThreshingExhaustParticleSystems, false);
	Utils.setEmittingState(self.thresherParticleSystems, false);
end;